#!/usr/bin/python
# -*- coding:utf-8 -*-

from gensim import corpora,models,similarities

STRICT = 0.3

def extra_same_elem(list1, list2):
    set1 = set(list1)
    set2 = set(list2)
    iset = set1.intersection(set2)
    return list(iset)

def find_close():
    for line in all_doc:
        split_anchor = []
        line2 = line.split()
        if not line in five_ini_cluster[0] and not line in five_ini_cluster[1] and not line in five_ini_cluster[2] and not line in five_ini_cluster[3] and not line in five_ini_cluster[4] and not line in five_ini_cluster[5] and not line in five_ini_cluster[6] and not line in five_ini_cluster[7] and not line in five_ini_cluster[8] and not line in five_ini_cluster[9]:
            
            doc_test_vec = dictionary.doc2bow(line2)
            sim = index[tfidf[doc_test_vec]]
            sim2 = zip(sim,all_doc)
        result =  sorted(sim2, key=lambda item: item[0], reverse=True)
        result = result[1:]
        if line in five_ini_cluster[0] or line in five_ini_cluster[1] or line in five_ini_cluster[2] or line in five_ini_cluster[3] or line in five_ini_cluster[4] or line in five_ini_cluster[5] or line in five_ini_cluster[6] or line in five_ini_cluster[7] or line in five_ini_cluster[8] or line in five_ini_cluster[9]:

            continue
        else:
            for rst in result:
                if rst[1] in five_ini_cluster[0] and rst[0] > STRICT:
                    five_ini_cluster[0].append(line)
                    break
                elif rst[1] in five_ini_cluster[1] and rst[0] > STRICT:
                    five_ini_cluster[1].append(line)
                    break
                elif rst[1] in five_ini_cluster[2] and rst[0] > STRICT:
                    five_ini_cluster[2].append(line)
                    break
                elif rst[1] in five_ini_cluster[3] and rst[0] > STRICT:
                    five_ini_cluster[3].append(line)
                    break
                elif rst[1] in five_ini_cluster[4] and rst[0] > STRICT:
                    five_ini_cluster[4].append(line)
                    break
                elif rst[1] in five_ini_cluster[5] and rst[0] > STRICT:
                    five_ini_cluster[5].append(line)
                    break
                elif rst[1] in five_ini_cluster[6] and rst[0] > STRICT:
                    five_ini_cluster[6].append(line)
                    break
                elif rst[1] in five_ini_cluster[7] and rst[0] > STRICT:
                    five_ini_cluster[7].append(line)
                    break
                elif rst[1] in five_ini_cluster[8] and rst[0] > STRICT:
                    five_ini_cluster[8].append(line)
                    break
                elif rst[1] in five_ini_cluster[9] and rst[0] > STRICT:
                    five_ini_cluster[9].append(line)
                    break
                else:
                    continue
    return

doc_test = []
all_doc = []
'''
with open("anchor.txt") as infile:
    for line in infile:
        if not line[:-1] in all_doc and not line[:-1] in doc_test:
            all_doc.append(line[:-1])
            doc_test.append(line[:-1])
infile.close()


with open("anchor.txt") as infile:
    for line in infile:
        all_doc.append(line[:-1])
        doc_test.append(line[:-1])
infile.close()
'''
all_sentence = []

with open("sentence2.txt") as infile1, open("anchor2.txt") as infile2, open("check.txt", "w") as outfile:
    for sen,anc in zip(infile1, infile2):
        if not sen[:-1] in all_sentence and not anc[:-1] in all_doc:
            all_sentence.append(sen[:-1])
            all_doc.append(anc[:-1])
            doc_test.append(anc[:-1])
            outfile.write(anc[:-1])
            outfile.write("\n")
infile1.close()
infile2.close()
outfile.close()
print len(all_sentence)
'''

with open("sentence.txt") as infile:
    for line in infile:
        all_sentence.append(line[:-1])
infile.close()
'''
all_doc_list = []

for doc in all_doc:
    doc_list = doc.split()
    all_doc_list.append(doc_list)

all_doc_test = []

for doc in doc_test:
    doc_test_list = doc.split()
    all_doc_test.append(doc_test_list)

dictionary = corpora.Dictionary(all_doc_list)
#print dictionary.keys()
#print dictionary.token2id
corpus = [dictionary.doc2bow(doc) for doc in all_doc_list]

top_ini = []
five_ini_cluster = []

#build a dictionary for anchor and sentence
DIC = dict(zip(all_doc, all_sentence))



for test,test2 in zip(all_doc_test, all_doc):
    doc_test_vec = dictionary.doc2bow(test)
    tfidf = models.TfidfModel(corpus)

    index = similarities.SparseMatrixSimilarity(tfidf[corpus], num_features=len(dictionary.keys()))

    sim = index[tfidf[doc_test_vec]]

    sim2 = zip(sim,all_doc)
    result =  sorted(sim2, key=lambda item: item[0], reverse=True)
    result_pair = list(result[1])
    result_pair.append(test2)
    top_ini.append(result_pair)
top_ini.sort(reverse=True)

five_ini_cluster.append(top_ini[0][1:3])
tmp_num = 1
for ini in top_ini:
    count = 0
    for ele in five_ini_cluster:
        if len(extra_same_elem(ini, ele)) == 1:
            break
        elif (count == len(five_ini_cluster) - 1 and len(extra_same_elem(ini, ele)) == 0):
            five_ini_cluster.append(ini[1:3])
            tmp_num += 1
        else:
            count += 1

        if tmp_num >= 10:
            break
    if tmp_num >= 10:
        break

for i in range(5):
    find_close()

with open("result.txt", "w") as outfile:
    outfile.write("Cluster1:\n")
    for anchor in five_ini_cluster[0]:
        sts = DIC.get(anchor)
        outfile.write("    Anchor:")
        outfile.write(anchor)
        outfile.write("\n")
        outfile.write("    Sentence:")
        outfile.write(sts)
        outfile.write("\n")
    outfile.write("\nCluster2:\n")
    for anchor in five_ini_cluster[1]:
        sts = DIC.get(anchor)
        outfile.write("    Anchor:")
        outfile.write(anchor)
        outfile.write("\n")
        outfile.write("    Sentence:")
        outfile.write(sts)
        outfile.write("\n")
    outfile.write("\nCluster3:\n")
    for anchor in five_ini_cluster[2]:
        sts = DIC.get(anchor)
        outfile.write("    Anchor:")
        outfile.write(anchor)
        outfile.write("\n")
        outfile.write("    Sentence:")
        outfile.write(sts)
        outfile.write("\n")
    outfile.write("\nCluster4:\n")
    for anchor in five_ini_cluster[3]:
        sts = DIC.get(anchor)
        outfile.write("    Anchor:")
        outfile.write(anchor)
        outfile.write("\n")
        outfile.write("    Sentence:")
        outfile.write(sts)
        outfile.write("\n")
    outfile.write("\nCluster5:\n")
    for anchor in five_ini_cluster[4]:
        sts = DIC.get(anchor)
        outfile.write("    Anchor:")
        outfile.write(anchor)
        outfile.write("\n")
        outfile.write("    Sentence:")
        outfile.write(sts)
        outfile.write("\n")
    outfile.write("\nCluster6:\n")
    for anchor in five_ini_cluster[5]:
        sts = DIC.get(anchor)
        outfile.write("    Anchor:")
        outfile.write(anchor)
        outfile.write("\n")
        outfile.write("    Sentence:")
        outfile.write(sts)
        outfile.write("\n")
    outfile.write("\nCluster7:\n")
    for anchor in five_ini_cluster[6]:
        sts = DIC.get(anchor)
        outfile.write("    Anchor:")
        outfile.write(anchor)
        outfile.write("\n")
        outfile.write("    Sentence:")
        outfile.write(sts)
        outfile.write("\n")
    outfile.write("\nCluster8:\n")
    for anchor in five_ini_cluster[7]:
        sts = DIC.get(anchor)
        outfile.write("    Anchor:")
        outfile.write(anchor)
        outfile.write("\n")
        outfile.write("    Sentence:")
        outfile.write(sts)
        outfile.write("\n")
    outfile.write("\nCluster9:\n")
    for anchor in five_ini_cluster[8]:
        sts = DIC.get(anchor)
        outfile.write("    Anchor:")
        outfile.write(anchor)
        outfile.write("\n")
        outfile.write("    Sentence:")
        outfile.write(sts)
        outfile.write("\n")
    outfile.write("\nCluster10:\n")
    for anchor in five_ini_cluster[9]:
        sts = DIC.get(anchor)
        outfile.write("    Anchor:")
        outfile.write(anchor)
        outfile.write("\n")
        outfile.write("    Sentence:")
        outfile.write(sts)
        outfile.write("\n")
outfile.close()

