with open("relations-cargo_ship--1000.json") as infile, open("sentence.txt", "w") as out_sentence, open("anchor.txt", "w") as out_anchor:
    for line in infile:
        subject_start = line.find("subject\":\"")
        subject_end = line.find("\",\"verb")
        if subject_start != -1 and subject_end != -1:
            sub = line[subject_start+10:subject_end]
        else:
            print "Cannot find subject!"
            continue
        verb_start = line.find("verb\":\"")
        verb_end = line.find("\",\"object")
        if verb_start != -1 and verb_end != -1:
            verb = line[verb_start+7:verb_end]
        else:
            print "Cannot find verb!"
            continue
        object_start = line.find("object\":\"")

        if object_start != -1:
            object = line[object_start+9:-3]
        else:
            print "Cannot find object!"
            continue
        if sub == object:
            continue
        anchor = sub + " " + verb + " " + object
        out_anchor.write(anchor)
        out_anchor.write("\n")

        sentence_end = line.find("\",\"subject")
        if sentence_end != -1:
            out_sentence.write(line[13:sentence_end])
            out_sentence.write("\n")
        else:
            print "Cannot find sentence!"
            continue
out_sentence.close()
out_anchor.close()